// v0.4 24.10.2020
// importing sound
  import processing.sound.*;
  SoundFile click;

// v0.3 21.10.2020
// moving everything into class
  int margin = 3;
  IntList imageIndex = new IntList();
  int[] flippedCard;

// v0.2 17.10.2020
// Outputting the card deck

// v0.1 16.10.2020
// Creating different scenes + images

  // set the scene
  int scene, score;
  int numCards = 20;
  //PImage[] cards = new PImage[numCards];
  Card[] cards = new Card[numCards];
  PImage[] images = new PImage[numCards];
  PImage cardCover;

// v0.1 14.10.2020
// Creating the text instructions

  PFont font;
  String instructions_1, instructions_2, instructions_3, instructions_4, btn_start, btn_quit;
  int fontSize = 50;

// v0. 13.10.2020
// Creating a button

  // defining colors as [r,g,b] arrays
  int[] pink = {242, 170, 224};
  int[] green = {51, 225, 142};
  int[] orange = {248, 163, 15};
  int[] blue = {103, 212, 239};
  int[] yellow = {255, 244, 108};
  
  // defining shape coordinates
  float rectX, rectY, rectWidth, rectHeight;
  
  void setup(){
    size(1100, 800);
    rectMode(CENTER);
    click = new SoundFile(this, "clickSound.wav"); 
    scene = 0;
    
    // setting the button coordinates
    rectX = width/2;
    rectY = height/2;
    rectWidth = 170;
    rectHeight = 80;
    
    // setting the text
    push();
      fontSize = 40;
      instructions_1 = "Welcome!";
      instructions_2 = "You are presented a deck of cards.";
      instructions_3 = "Your task is to flip and match every one of them.";
    pop();
    
    btn_start = "START";
    btn_quit = "QUIT";
    font = createFont("VT323-Regular", fontSize);
    textFont(font);
    
    // setting flipped cards to null
    flippedCard = new int[2];
    score = 0;
    
    // load cards once
    loadCards();
  }
  
  void draw(){
    background(green[0], green[1], green[2]);
    // display scenes
    if (scene == 0){
      displayMenu();
    }
    if (scene == 1){
      playScene();
      //displayScore();
    }
    if (scene == 2){
      playWin();
    }
  }
    
  // display the UI scene
  void displayMenu(){
    
    // create a button
    push();
      noStroke();
      if(isHover())
        fill(yellow[0]-20,yellow[1]-20,yellow[2]-20);
      else
        fill(yellow[0],yellow[1],yellow[2]);
      rect(rectX, rectY, rectWidth, rectHeight);
    pop();
    
    // place instructions
    textAlign(CENTER);
    fill(0);
    text(instructions_1, width/2, height/6);
    text(instructions_2, width/2, height/6+80);
    text(instructions_3, width/2, height/6+120);
    text(btn_start, width/2, height/2+12.5);
    push();
      textSize(22);
      text("Intro to IM, Fall 2020", width/2, 3*height/4);
    pop();
  }
  
  // check if the mouse is over the button
  boolean isHover(){
    if(mouseX <= rectX+rectWidth/2 
      && mouseX >= rectX - rectWidth/2
      && mouseY <= rectY + rectHeight/2
      && mouseY >= rectY - rectHeight/2 && mousePressed){
      scene = 1;
      return true;
    }
     else
       return false;
  }
  
  // display scene 1
  void playScene(){
    background(blue[0], blue[1], blue[2]);
    
    // show the cards
    for (int i =0; i<numCards; i++){
      cards[i].displayCards();
    }
    push();
      textSize(60);
      text("Score: " + score, width-200, height/2);
    pop();
  }
  
  // load cards
  void loadCards(){
    
    // store all the cards in the image array
    for (int i = 0; i < numCards; i ++) {
      images[i] = loadImage(i+".png");
      imageIndex.append(i);
    }
    
    // initialize counters
    int counter = 0;
    int index;
    
    // initialize a deck matrix
    for (int i = 0; i < 5; i++) { //i = x
      for (int j = 0; j < 4; j++) {//j = y
        index = i + j * 5; // width is 5
        cards[index] = new Card(i*(margin+images[i].width), j*(margin+images[i].height), images[imageIndex.get(counter)], index);
        counter++;
      }
    }

    // shuffle images
    imageIndex.shuffle(); 
  }
  
  // flip the cards
  void mousePressed(){
    
     // add sound
     click.play();
    
     for (int i = 0; i<numCards; i++){
       cards[i].flipCard();

        if (flippedCard[0] == -1){
          flippedCard[0] = cards[i].value;
        }
        
        else{
          flippedCard[1] = cards[i].value;
        }
        // compare flipped cards
        if (flippedCard[0] != -1 && flippedCard[1] != -1){
          if (flippedCard[0] == (flippedCard[1] - 10) || flippedCard[0] == (flippedCard[1] + 10)){
            score++;
             // check for win
             if (score == numCards/2){
               scene = 2;
            }
          // flip cards back if they don't match
          else {
            cards[i].isFlipped = false;
          }
          // reset the storage array
            flippedCard[0] = -1;
            flippedCard[1] = -1;
          }
        }
      }
    }
  
  // display the win scene
  void playWin(){
     background(pink[0], pink[1], pink[2]);
     text("You have matched them all!", width/2, height/2-200);
     push();
      noStroke();
      if(isHover())
        fill(yellow[0]-20,yellow[1]-20,yellow[2]-20);
      else
        fill(yellow[0],yellow[1],yellow[2]);
      rect(rectX, rectY, 2*rectWidth, rectHeight);
    pop();
    text("Play Again?", rectX, rectY+10);
    score = 0;
    // reset the cards
    for (int i = 0; i < numCards; i++){
      cards[i].isFlipped = false;
    }
  }
